C $Header$
C $Name$

C This file contains cog templates.
C Code between template and end marker is autogenerated.
C Add new forcing fields to exfflds in exf.py
C
CCOG[[[cog import cog; from exf import *]]]
CCOG[[[end]]] (checksum: d41d8cd98f00b204e9800998ecf8427e)

#include "GUD_OPTIONS.h"
#include "EXF_OPTIONS.h"

CBOP
C !ROUTINE: GUD_EXF_LOAD

C !INTERFACE: ==========================================================
      SUBROUTINE GUD_EXF_LOAD( mytime, myiter, mythid )

C !DESCRIPTION:
C     Load and interpolate forcing fields for gud package

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXF
#include "EXF_PARAM.h"
#endif
#ifdef ALLOW_GUD
#include "GUD_SIZE.h"
#include "GUD_EXF.h"
#endif

C !INPUT PARAMETERS: ===================================================
      _RL     mytime
      integer myiter
      integer mythid
CEOP

#ifdef ALLOW_GUD
#ifdef ALLOW_EXF

C !LOCAL VARIABLES: ====================================================
#ifdef GUD_ALLOW_RADTRANS
      INTEGER l
#endif

c--   read forcing fields from files and temporal interpolation

      IF (.NOT.(gud_loadFieldsEarly.AND.myiter.EQ.niter0)) THEN
#ifdef GUD_ALLOW_RADTRANS
       DO l = 1, nlam
        call exf_set_gen(
     &     OASIM_Edfile(l), OASIMstartdate, OASIMperiod,
     &     gud_inscal_OASIM(l),
     &     OASIM_exfremo_intercept, OASIM_exfremo_slope,
     &     OASIM_Ed(1-OLx,1-OLy,1,1,l),
     &     OASIM_Ed0(1-OLx,1-OLy,1,1,l),
     &     OASIM_Ed1(1-OLx,1-OLy,1,1,l),
     &     OASIMmask,
#ifdef USE_EXF_INTERPOLATION
     &     OASIM_lon0, OASIM_lon_inc,
     &     OASIM_lat0, OASIM_lat_inc,
     &     OASIM_nlon, OASIM_nlat, xC, yC, OASIM_interpMethod,
#endif
     &     mytime, myiter, mythid )

        call exf_set_gen(
     &     OASIM_Esfile(l), OASIMstartdate, OASIMperiod,
     &     gud_inscal_OASIM(l),
     &     OASIM_exfremo_intercept, OASIM_exfremo_slope,
     &     OASIM_Es(1-OLx,1-OLy,1,1,l),
     &     OASIM_Es0(1-OLx,1-OLy,1,1,l),
     &     OASIM_Es1(1-OLx,1-OLy,1,1,l),
     &     OASIMmask,
#ifdef USE_EXF_INTERPOLATION
     &     OASIM_lon0, OASIM_lon_inc,
     &     OASIM_lat0, OASIM_lat_inc,
     &     OASIM_nlon, OASIM_nlat, xC, yC, OASIM_interpMethod,
#endif
     &     mytime, myiter, mythid )
       ENDDO
#endif
CCOG[[[cog
CCOGfor fld,pre in exfflds: cog.out('''
CCOG       call exf_set_gen(
CCOG     &     {pre}file, {pre}startdate, {pre}period,
CCOG     &     gud_inscal_{pre},
CCOG     &     {pre}_exfremo_intercept, {pre}_exfremo_slope,
CCOG     &     {fld}, {pre}0, {pre}1, {pre}mask,
CCOG#ifdef USE_EXF_INTERPOLATION
CCOG     &     {pre}_lon0, {pre}_lon_inc,
CCOG     &     {pre}_lat0, {pre}_lat_inc,
CCOG     &     {pre}_nlon, {pre}_nlat, xC, yC, {pre}_interpMethod,
CCOG#endif
CCOG     &     mytime, myiter, mythid )
CCOG'''.format(pre=pre, fld=fld))
CCOG]]]

       call exf_set_gen(
     &     PARfile, PARstartdate, PARperiod,
     &     gud_inscal_PAR,
     &     PAR_exfremo_intercept, PAR_exfremo_slope,
     &     surfPAR, PAR0, PAR1, PARmask,
#ifdef USE_EXF_INTERPOLATION
     &     PAR_lon0, PAR_lon_inc,
     &     PAR_lat0, PAR_lat_inc,
     &     PAR_nlon, PAR_nlat, xC, yC, PAR_interpMethod,
#endif
     &     mytime, myiter, mythid )

       call exf_set_gen(
     &     ironfile, ironstartdate, ironperiod,
     &     gud_inscal_iron,
     &     iron_exfremo_intercept, iron_exfremo_slope,
     &     inputFe, iron0, iron1, ironmask,
#ifdef USE_EXF_INTERPOLATION
     &     iron_lon0, iron_lon_inc,
     &     iron_lat0, iron_lat_inc,
     &     iron_nlon, iron_nlat, xC, yC, iron_interpMethod,
#endif
     &     mytime, myiter, mythid )

       call exf_set_gen(
     &     icefile, icestartdate, iceperiod,
     &     gud_inscal_ice,
     &     ice_exfremo_intercept, ice_exfremo_slope,
     &     iceFrac, ice0, ice1, icemask,
#ifdef USE_EXF_INTERPOLATION
     &     ice_lon0, ice_lon_inc,
     &     ice_lat0, ice_lat_inc,
     &     ice_nlon, ice_nlat, xC, yC, ice_interpMethod,
#endif
     &     mytime, myiter, mythid )

       call exf_set_gen(
     &     windfile, windstartdate, windperiod,
     &     gud_inscal_wind,
     &     wind_exfremo_intercept, wind_exfremo_slope,
     &     windSpeed, wind0, wind1, windmask,
#ifdef USE_EXF_INTERPOLATION
     &     wind_lon0, wind_lon_inc,
     &     wind_lat0, wind_lat_inc,
     &     wind_nlon, wind_nlat, xC, yC, wind_interpMethod,
#endif
     &     mytime, myiter, mythid )

       call exf_set_gen(
     &     pCO2file, pCO2startdate, pCO2period,
     &     gud_inscal_pCO2,
     &     pCO2_exfremo_intercept, pCO2_exfremo_slope,
     &     atmospCO2, pCO20, pCO21, pCO2mask,
#ifdef USE_EXF_INTERPOLATION
     &     pCO2_lon0, pCO2_lon_inc,
     &     pCO2_lat0, pCO2_lat_inc,
     &     pCO2_nlon, pCO2_nlat, xC, yC, pCO2_interpMethod,
#endif
     &     mytime, myiter, mythid )
CCOG[[[end]]] (checksum: bd498f4f93d2729d57f1cc7f146d3219)
      ENDIF

#endif /* ALLOW_EXF */
#endif /* ALLOW_GUD */

      RETURN
      END
