C $Header: /u/gcmpack/MITgcm/pkg/hg/hg0_surfforcing.F,v 1.3 2006/08/06 01:29:12 jmc Exp $
C $Name: checkpoint64g $

#include "CPP_OPTIONS.h"
#include "GCHEM_OPTIONS.h"
#include "HG_OPTIONS.h"
#ifdef USE_EXFIWR
#include "SEAICE_OPTIONS.h"
#include "EXF_OPTIONS.h"
#endif

CStartOfInterFace
      SUBROUTINE hg0_SURFFORCING( PTR, surfhg0,
     I           bi,bj,iMin,iMax,jMin,jMax,
     I           myIter, myTime, myThid )
C     /==========================================================\
C     | SUBROUTINE HG0_SURFFORCING                               |
C     |==========================================================|
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"

#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "GCHEM.h"
#include "HG_SIZE.h"
#include "HG.h"

#ifdef USE_EXFIWR
#include "SEAICE_SIZE.h"
#include "SEAICE.h"
#include "EXF_FIELDS.h"
#endif

#ifdef COUPLE_GEOSChem
      INTEGER this_year,this_month,this_day,this_hour
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER(LEN=255) filename
#endif
C     == Routine arguments ==
      INTEGER myIter, myThid
      _RL myTime
      _RL  Ptr  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy,PTRACERS_num)
      _RL  surfhg0(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef COUPLE_GEOSChem
      _RL  SfcHg0(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  SfcHgT(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
      INTEGER iMin,iMax,jMin,jMax, bi, bj

#ifdef ALLOW_PTRACERS
#ifdef ALLOW_HG

C     == Local variables ==
C I, J, K - Loop counters
      INTEGER I,J,P
C Solubility relation coefficients
      _RL SchmidtNohg0, ScCO2
      _RL Kwexch
      _RL FluxHG0(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL tk, tc, vi, D, H
      _RL doco, iceo, pisvelo
      _RL total_river_1
      LOGICAL isrivermouth
      INTEGER i1,j1,month
#ifdef ALLOW_DIAGNOSTICS      
      _RL hg0conc_diag(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hg0evas_diag(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hg0conco
      CHARACTER*8 diagname
#endif
C#ifdef COUPLE_GEOSChem
C      CHARACTER*(MAX_LEN_MBUF) suff
C	  CHARACTER*(MAX_LEN_MBUF) msgBuf
C#endif

C Initialize diagnostics
#ifdef ALLOW_DIAGNOSTICS
      DO j=jMin,jMax
        DO i=iMin,iMax
            hg0conc_diag(i,j)=0d0
            hg0evas_diag(i,j)=0d0
        ENDDO
      ENDDO
#endif

C Get the current month
      month=mod(int(myTime/2629800.0), 12) + 1
C     WRITE(standardmessageunit,'(A,1x,I2)')
C     &               'current month: ',month
                  
C calculate SCHMIDT NO.
        DO j=jMin,jMax
          DO i=iMin,iMax
C Locoalize variables              
            hg0conco = max(hg0conc(i,j,bi,bj),0d0)
#ifdef USE_EXFIWR
            iceo = AREA(i,j,bi,bj)
            pisvelo = 6.94 _d -7 * wspeed(i,j,bi,bj) ** 2
#else
            iceo = fice(i,j,bi,bj)
#ifdef COUPLE_GEOSChem
			pisvelo = 6.94 _d -7 * Usq(i,j,bi,bj)
#else
			! monthly wind speed need to be read, and
			! piston velocity calculated in hg_fields_load.F 
			pisvelo = pisvel(i,j,bi,bj)
#endif
#endif
            
            IF (HFacC(i,j,1,bi,bj).GT.0 _d 0) THEN

C Is this a river mouth grid
#ifdef USE_EXFIWR
              total_river_1 = 0d0
              DO j1=j-4,j+4
              DO i1=i-4,i+4
               IF (i1 .GE. iMin .AND. i1 .LE. iMax .AND.
     &             j1 .GE. jMin .AND. j1 .LE. jMax .AND.
     &             HFacC(i1,j1,1,bi,bj) .GT. 0.5 _d 0 ) THEN
                total_river_1 = total_river_1
     &           + hg2river(i1,j1,bi,bj) + hgpriver(i1,j1,bi,bj)
#ifdef HG2REFRACTORY
     &           + hg2rriver(i1,j1,bi,bj)
#endif
#ifdef HGPREFRACTORY
     &           + hgprriver(i1,j1,bi,bj,1)
#endif
               ENDIF
              ENDDO
              ENDDO

              IF ( total_river_1 .gt. 1d-32 ) THEN
                 isrivermouth = .TRUE.
              ELSE
                 isrivermouth = .FALSE.
              ENDIF
#endif

C Locoalize variables
              doco     = max(doc(i,j,1,bi,bj),0d0)
                              
C calculate SCHMIDT NO. for Hg0
C yxzhang, theta in Celcuis degree
              tc = max(theta(i,j,1,bi,bj), 0 _d 0)
              !Note: this is a drawback of current settings. We don't
              !consider the temperature of runoff, and assume the runoff
              !temperature equals to that of SST. This is not the case.
              !According to the study by
              !Nghiem and colleagues (2014), the average surface temperature of
              !the open water rose by 6.5°C (11.7°Fahrenheit) after the
              !pulse from the Mackenzie. Temperatures were 10°C at 287
              !kilometers (178 miles) from the coast and 8°C as far as
              !350 kilometers (217 miles) away.
              !Improve this when we get better information for the
              !runoff temperature.
#ifdef USE_EXFIWR
              IF ( isrivermouth .AND. 
     &             month .GE. 6 .AND. month .LE. 7) THEN
C                disable this because setting runoff temperature in
C                exf_mapfields.F
                 tc = tc + 10.0
              ENDIF
#endif
              tk = tc + 273.15 _d 0
              vi = ( 10**( ( 1301.0d0 / ( 998.333d0 + 8.1855d0
     &              * ( tc - 20.0d0 )+ 0.00585d0 * (tc - 20.0d0 )**2 ) )
     &              - 3.30233d0 ) ) * 100.0d0
              D = 9.37 _d -8 * tk / vi
              SchmidtNohg0 =
     &            0.017 _d 0 * exp( - 0.025 _d 0 * tc ) / D
              ScCO2  = 644.7d0 + tc * ( -6.16d0 + tc * ( 0.11d0 ) )
c calculate Henry's law constant for Hg0, L air/L water
              H = exp( ( -2404.3d0 / tk ) + 6.92d0 )
C Determine surface flux (Fhg0), m/s

              ! Seasonal sea ice region, air-sea exchange is enhanced
              ! because of turbulance and mixing (Loose et al. Ocean
              ! Science 2014)
              IF ( (iceo .gt. 0.01 .and. iceo .lt. 0.99)
#ifdef USE_EXFIWR
     &             .OR. isrivermouth
#endif  
     &             ) THEN
                  pisvelo = pisvelo * 2.0
              ENDIF
              ! increase another factor of 2 when fraction of open water
              ! is between 0.2 and 0.6, i.e. non linear effect in Fig.
              ! 10 of Loose et al. 2014.
              IF ( iceo .gt. 0.4 .and. iceo .lt. 0.8 ) THEN
                  pisvelo = pisvelo * 2.0
              ENDIF
              ! increase another factor of 2 when the salinity is
              ! largely decreased during June and July in river mouth.
              ! This is an assumption so far.
              IF ( month .gt. 5 .and. month .lt. 8 
     &              .and. isrivermouth ) THEN
                  pisvelo = pisvelo * 2.0
              ENDIF

              ! ice fraction is zero at river mouth (and nearby grids) if runoff exists               
#ifdef USE_EXFIWR
              IF ( isrivermouth .AND. 
     &             month .GT. 2 .AND. month .LT. 11 ) THEN
                  iceo = 0.0 _d 0 
              ENDIF
#endif
              Kwexch = (1. _d 0 - iceo)
     &                    * pisvelo
     &                    / sqrt( SchmidtNoHG0 / ScCO2 )

              FluxHG0(i,j,bi,bj) =
     &                    Kwexch * (hg0conco * 4.985 _d -12   !ng/m3->mol/m3
     &                    / H - max(PTR(i,j,1,bi,bj,ihg0),0d0))
            ELSE
              FluxHG0(i,j,bi,bj) = 0. _d 0
            ENDIF
C Calculate diagnistics
#ifdef ALLOW_DIAGNOSTICS
            hg0conc_diag(i,j) = HG0conco  !ng/m^3
            hg0evas_diag(i,j) = -FluxHG0(i,j,bi,bj)  !mol/m^2/s
#endif            
          ENDDO
        ENDDO

C update surface tendencies, cap it with available hg0 at surface layer      
        DO j=jMin,jMax
          DO i=iMin,iMax
           SURFHG0(i,j) = max(FluxHG0(i,j,bi,bj)*recip_drF(1),
     &           -max(PTR(i,j,1,bi,bj,ihg0),0d0)/deltaTclock)
          ENDDO
        ENDDO
       
c write diagnostics
#ifdef ALLOW_DIAGNOSTICS
        WRITE(diagname,'(A8)') 'HG0CONC '
        CALL DIAGNOSTICS_FILL( hg0conc_diag(1-Olx,1-Oly), diagname,
     &                         0,1,2,bi,bj,myThid )
        WRITE(diagname,'(A8)') 'HG0EVAS '
        CALL DIAGNOSTICS_FILL( hg0evas_diag(1-Olx,1-Oly), diagname,
     &                         0,1,2,bi,bj,myThid )     
#endif

c coupling with GEOS-Chem
#ifdef COUPLE_GEOSChem
C     surface hg0 concentrations
        SfcHg0 = PTR(:,:,1,:,:,iHg0)
        SfcHgT = SUM(PTR(:,:,1,:,:,:),5)

        ! Transfer myIter to year month day hour
        ! 518400 is 2100.12.30 24:00
        ! 300240 is 2000.1.1 00:00
        ! deltaTClock = 4 hours
        THIS_HOUR = MOD(myIter - 300240, 6) * 4
        THIS_DAY = MOD(myIter - 300240 - THIS_HOUR / 4, 180) / 6 + 1
        THIS_MONTH = MOD(myIter - 300240 - THIS_HOUR / 4 - 
     &               6 * (THIS_DAY - 1), 2160) / 180 + 1
        THIS_YEAR = (myIter - 300240 - THIS_HOUR / 4 - 
     &              6 * (THIS_DAY-1) - 180 * (THIS_MONTH - 1))
     &             / 2160 + 2000
     
c    write hourly output files
        WRITE (suff,'(I4,3I2.2)') THIS_YEAR,
     &             THIS_MONTH, THIS_DAY, THIS_HOUR 

        _BARRIER
        CALL WRITE_FLD_XY_RL( 'MG_OUT/MG.', 
     &        suff, FluxHG0,myIter, myThid)
        CALL WRITE_FLD_XY_RL( 'MG_OUTa/Hg0Aq.',
     &        suff, SfcHg0, myIter, myThid)
        CALL WRITE_FLD_XY_RL( 'MG_OUTa/HgTAq.',
     &        suff, SfcHgT, myIter, myThid)

         _BEGIN_MASTER(myThid)         
         WRITE(msgBuf,'(2A)') 'Writing MG.', suff
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid)
         ! Write a ready file if finish writing
	     FILENAME = 'MG_OUT/MG.' // TRIM( suff ) // '.ready'
	     OPEN(UNIT=31,FILE=FILENAME,STATUS='UNKNOWN')
	     CLOSE(31)
     
         _END_MASTER(myThid)
#endif

#endif
#endif
        RETURN
        END
