C $Header: /u/gcmpack/MITgcm/pkg/microp/microp_surfforcing.F,v 1.3 2006/08/06 01:29:12 jmc Exp $
C $Name: checkpoint64g $

#include "GCHEM_OPTIONS.h"
#include "MICROP_OPTIONS.h"

CStartOfInterFace
      SUBROUTINE microp_surfforcing( Ptr, surfmicrop,
     I           bi,bj,iMin,iMax,jMin,jMax,
     I           myIter, myTime, myThid )
C     /==========================================================\
C     | SUBROUTINE microp_surfforcing                            |
C     |==========================================================|
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "MICROP_SIZE.h"
#include "MICROP.h"

C     == Routine arguments ==
      INTEGER myIter, myThid
      _RL myTime
      INTEGER iMin,iMax,jMin,jMax, bi, bj
      _RL  Ptr  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy,PTRACERS_num)
      _RL  surfmicrop(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      
#ifdef ALLOW_PTRACERS
#ifdef ALLOW_MICROP
      _RL  Fluxmicrop(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  microprivero
#ifdef ALLOW_DIAGNOSTICS
      _RL  micropriver_diag(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      CHARACTER*8 diagname

C     == Local variables ==
C I, J - Loop counters
      INTEGER I,J

C Initialize diagnostics
#ifdef ALLOW_DIAGNOSTICS
      DO j=jMin,jMax
        DO i=iMin,iMax
            micropriver_diag(i,j)=0d0
        ENDDO
      ENDDO
#endif
      
      DO j=jMin,jMax
        DO i=iMin,iMax
          IF (HFacC(i,j,1,bi,bj).GT.0.5) THEN
C Localize variabls
C            #/s -> #/m2/s
             microprivero = micropriver(i,j,bi,bj)
     &           *recip_rA(i,j,bi,bj)
                           
             Fluxmicrop(i,j)=microprivero
#ifdef ALLOW_DIAGNOSTICS             
             micropriver_diag(i,j)=micropriver_diag(i,j)+
     &           Fluxmicrop(i,j)
#endif             

          ENDIF
        ENDDO
      ENDDO

C update surface tendencies
        DO j=jMin,jMax
          DO i=iMin,iMax
            surfmicrop(i,j)=
     &         HFacC(i,j,1,bi,bj)*Fluxmicrop(i,j)*recip_drF(1)
          ENDDO
         ENDDO
         
c write diagnostics
#ifdef ALLOW_DIAGNOSTICS
        WRITE(diagname,'(A8)') 'MPRIVER '
        CALL DIAGNOSTICS_FILL( micropriver_diag(1-Olx,1-Oly), diagname,
     &                         0,1,2,bi,bj,myThid )         
#endif
         
#endif
#endif
#endif
        RETURN
        END

